Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ObjectPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ObjectPool.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ObjectPool.cs	(revision 14777)
@@ -0,0 +1,105 @@
+﻿// Licensed to the .NET Foundation under one or more agreements.
+// The .NET Foundation licenses this file to you under the MIT license.
+// See the LICENSE file in the project root for more information.
+
+using System;
+
+namespace TestPooling.Pool {
+  using System.Threading;
+
+  /// <summary>
+  /// Generic implementation of object pooling pattern with predefined pool size limit. The main
+  /// purpose is that limited number of frequently used objects can be kept in the pool for
+  /// further recycling.
+  ///
+  /// Notes:
+  /// 1) it is not the goal to keep all returned objects. Pool is not meant for storage. If there
+  ///    is no space in the pool, extra returned objects will be dropped.
+  ///
+  /// 2) it is implied that if object was obtained from a pool, the caller will return it back in
+  ///    a relatively short time. Keeping checked out objects for long durations is ok, but
+  ///    reduces usefulness of pooling. Just new up your own.
+  ///
+  /// Not returning objects to the pool in not detrimental to the pool's work, but is a bad practice.
+  /// Rationale:
+  ///    If there is no intent for reusing the object, do not use pool - just use "new".
+  /// </summary>
+  public sealed class ObjectPool<T> where T : class {
+    private struct Element {
+      internal T Value;
+    }
+
+    // storage for the pool objects.
+    private readonly Element[] _items;
+
+    // factory is stored for the lifetime of the pool. We will call this only when pool needs to
+    // expand. compared to "new T()", Func gives more flexibility to implementers and faster
+    // than "new T()".
+    private readonly Func<T> _factory;
+
+
+    internal ObjectPool(Func<T> factory)
+        : this(factory, Environment.ProcessorCount * 2) { }
+
+    internal ObjectPool(Func<T> factory, int size) {
+      _factory = factory;
+      _items = new Element[size];
+    }
+
+    private T CreateInstance() {
+      var inst = _factory();
+      return inst;
+    }
+
+    /// <summary>
+    /// Produces an instance.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search.
+    /// </remarks>
+    internal T Allocate() {
+      var items = _items;
+      T inst;
+
+      for (int i = 0; i < items.Length; i++) {
+        // Note that the read is optimistically not synchronized. That is intentional.
+        // We will interlock only when we have a candidate. in a worst case we may miss some
+        // recently returned objects. Not a big deal.
+        inst = items[i].Value;
+        if (inst != null) {
+          if (inst == Interlocked.CompareExchange(ref items[i].Value, null, inst)) {
+            goto gotInstance;
+          }
+        }
+      }
+
+      inst = CreateInstance();
+      gotInstance:
+
+      return inst;
+    }
+
+    /// <summary>
+    /// Returns objects to the pool.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search in Allocate.
+    /// </remarks>
+    internal void Free(T obj) {
+      var items = _items;
+      for (int i = 0; i < items.Length; i++) {
+        if (items[i].Value == null) {
+          // Intentionally not using interlocked here.
+          // In a worst case scenario two objects may be stored into same slot.
+          // It is very unlikely to happen and will only mean that one of the objects will get collected.
+          items[i].Value = obj;
+          break;
+        }
+      }
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/PooledList.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/PooledList.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/PooledList.cs	(revision 14777)
@@ -0,0 +1,12 @@
+﻿using System.Collections.Generic;
+
+namespace TestPooling.Pool {
+  using System;
+
+  [Serializable]
+  public class PooledList<T> : List<T>, IPooledObject {
+    public void Reset() {
+      this.Clear();
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 14777)
@@ -0,0 +1,529 @@
+﻿using System.Threading.Tasks;
+
+namespace TestPooling {
+  using System;
+  using System.Collections.Generic;
+  using System.Diagnostics;
+  using System.Linq;
+  using System.Threading;
+  using DirtyList;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Simplifier;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using HeuristicLab.Random;
+
+  using TestPooling.Pool;
+
+  class Program {
+    private const int PartitionSize = 512;
+    private const int ExampleCount = 200;
+    private const int InstanceCount = 1024;
+    private const int PopulationCount = 100;
+
+    private static int TotalInstanceCount => PopulationCount * InstanceCount * ExampleCount;
+
+    static void Main(string[] args) {
+      //Test1();
+      //Test1_2();
+      //Test3();
+
+      //TestCollectionPooling();
+
+      //DirtyListTest();
+
+      //TestAddRangeNConcat();
+
+      //TestStacks();
+
+      //SimpleTest();
+      //Stepwise().Wait();
+      //PerformanceTestInterpreter();
+      //PerformanceParallelTestInterpreter();
+      //PerformanceTestLinearCodeGenerator();
+      TestRobustness();
+      //TestPool();
+      //TestPoolPerformance();
+      //TestSimplifier();
+      //FlagsTest();
+      //TestExpressionDependencies();
+
+      Console.WriteLine("\nPress any key to continue...");
+      Console.ReadKey(false);
+    }
+
+    private static void TestExpressionDependencies() {
+      var enabledExpressions = ExpressionTable.GetEnabledExpressionsByStackTypes(StackTypes.Boolean | StackTypes.Integer);
+    }
+
+    private static void FlagsTest() {
+      var types = StackTypes.Boolean | StackTypes.Char | StackTypes.Integer;
+
+      StackTypes test1 = (StackTypes)(StackTypes.Boolean - types);
+      StackTypes test2 = (StackTypes)((StackTypes.Boolean | StackTypes.Float) - types);
+      StackTypes test3 = ((StackTypes.Boolean | StackTypes.Float) & types);
+      StackTypes test4 = ((StackTypes.Boolean | StackTypes.Float) ^ types);
+      StackTypes test5 = ((StackTypes.Boolean | StackTypes.Float) | types);
+      StackTypes test6 = (StackTypes.Boolean | StackTypes.Float) & ~types;
+      StackTypes test7 = StackTypes.Boolean & ~types;
+    }
+
+    private static void TestStacks() {
+      var sw = new Stopwatch();
+      var stack = new DirtyList.PushStack<int>();
+      var stack2 = new PushStack2<int>();
+      var stack3 = new PushStack3<int>();
+      var listC = new List<int>(1000);
+      var count = 200000;
+      var repeats = 10;
+
+      for (var i = 0; i < 100; i++) {
+        listC.Add(i);
+      }
+
+      sw.Start();
+      for (var j = 0; j < repeats; j++) {
+        stack.Clear();
+
+        for (int i = 0; i < count; i++) {
+          stack.Push(listC);
+        }
+      }
+      sw.Stop();
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds / repeats);
+
+      sw.Restart();
+      for (var j = 0; j < repeats; j++) {
+        stack2.Clear();
+
+        for (int i = 0; i < count; i++) {
+          stack2.PushRange(listC);
+        }
+      }
+      sw.Stop();
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds / repeats);
+
+      sw.Restart();
+      for (var j = 0; j < repeats; j++) {
+        stack3.Clear();
+
+        for (int i = 0; i < count; i++) {
+          stack3.PushRange(listC);
+        }
+      }
+      sw.Stop();
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds / repeats);
+
+      sw.Restart();
+      for (int i = 0; i < count * listC.Count; i++) {
+        stack.Pop();
+      }
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds);
+
+      sw.Restart();
+      for (int i = 0; i < count * listC.Count; i++) {
+        stack2.Pop();
+      }
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds);
+
+
+    }
+
+    private static void TestAddRangeNConcat() {
+      var sw = new Stopwatch();
+      var count = 10000;
+      var listA = new List<int>();
+      var listB = new List<int>();
+      var listC = new List<int>(1000);
+
+      for (var i = 0; i < 1000; i++) {
+        listC.Add(i);
+      }
+
+      sw.Start();
+      for (int i = 0; i < count; i++) {
+        listA.AddRange(listC);
+      }
+      sw.Stop();
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds);
+
+      sw.Restart();
+      for (int i = 0; i < count; i++) {
+        listB = listB.Concat(listC).ToList();
+      }
+      sw.Stop();
+
+      Console.WriteLine("{0}", sw.ElapsedMilliseconds);
+
+    }
+
+    private static void DirtyListTest() {
+      var sw = new Stopwatch();
+      var provider = new ManagedPoolProvider<Person>(100, () => new Person());
+      var provider2 = new ManagedPoolProvider<Person>(100, () => new Person());
+      var dl = new DirtyList<Person>();
+      var l = new List<Person>();
+
+      sw.Start();
+      for (var i = 0; i < 30000000; i++) {
+        using (var pool = provider.CreatePool()) {
+          for (var j = 0; j < 2; j++) {
+            var person = pool.Get();
+            person.Age = i + j;
+            person.Name = (i + j).ToString();
+
+            dl.Add(person);
+          }
+        }
+
+        dl.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine("DirtyList: {0}", sw.Elapsed.TotalSeconds);
+
+      sw.Restart();
+      for (var i = 0; i < 30000000; i++) {
+        using (var pool = provider2.CreatePool()) {
+          for (var j = 0; j < 2; j++) {
+            var person = pool.Get();
+            person.Age = i + j;
+            person.Name = (i + j).ToString();
+
+            l.Add(person);
+          }
+        }
+
+        l.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine("List: {0}", sw.Elapsed.TotalSeconds);
+    }
+
+    private static void TestCollectionPooling() {
+      var sw = new Stopwatch();
+      sw.Start();
+
+      var provider = new ManagedPoolProvider<PooledList<Person>>(PartitionSize, () => new PooledList<Person>());
+
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          using (var pool = provider.CreatePool()) {
+            var list = pool.Get();
+
+            for (var i = 0; i < InstanceCount; i++)
+              list.Add(new Person {
+                Age = pc + e + i,
+                Name = string.Format("{0} - {1} - {2}", pc, e, i)
+              });
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("Collection Pooling - Duration: {0} - {1} for {2}/{3} instances", sw.ElapsedTicks, sw.Elapsed.TotalSeconds, provider.InstanceCount, TotalInstanceCount);
+    }
+
+
+    private static void Test1() {
+      var sw = new Stopwatch();
+
+      sw.Start();
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          using (var pool = new ManagedPool<Person>(PartitionSize, () => new Person())) {
+            for (var i = 0; i < InstanceCount; i++) {
+              var person = pool.Get();
+              person.Age = pc + e + i;
+              person.Name = string.Format("{0} - {1} - {2}", pc, e, i);
+            }
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("1 - Duration: {0} - {1} for {2}/{3} instances", sw.ElapsedTicks, sw.Elapsed.TotalSeconds, ManagedPool<Person>.InstanceCount, TotalInstanceCount);
+    }
+
+    private static void Test1_2() {
+      var sw = new Stopwatch();
+      sw.Start();
+
+      var provider = new ManagedPoolProvider<Person>(PartitionSize, () => new Person());
+
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          using (var pool = provider.CreatePool()) {
+            for (var i = 0; i < InstanceCount; i++) {
+              var person = pool.Get();
+              person.Age = pc + e + i;
+              person.Name = string.Format("{0} - {1} - {2}", pc, e, i);
+            }
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("1_2 - Duration: {0} - {1} for {2}/{3} instances", sw.ElapsedTicks, sw.Elapsed.TotalSeconds, provider.InstanceCount, TotalInstanceCount);
+    }
+
+    private static void Test3() {
+      var count = 0;
+      var sw = new Stopwatch();
+
+      sw.Start();
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          var list = new Person[InstanceCount];
+          for (var i = 0; i < InstanceCount; i++) {
+            list[i] = new Person {
+              Age = pc + e + i,
+              Name = string.Format("{0} - {1} - {2}", pc, e, i)
+            };
+          }
+
+          Interlocked.Add(ref count, list.Length);
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("3 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
+      Console.WriteLine("PartitionSize: {0}", count);
+    }
+
+    private static void Test2() {
+      var pool = new ObjectPool<Person>(() => new Person(), 2048);
+
+      Parallel.For(0, 10000, i => {
+        for (var j = 0; j < 3000; j++) {
+          var person = pool.Allocate();
+          person.Age = i + j;
+          person.Name = string.Format("{0} - {1}", i, j);
+        }
+
+        //pool.Free()
+      });
+    }
+
+    static void SimpleTest() {
+      var interpreter = new PushInterpreter();
+
+      interpreter.Run("5 INTEGER.DUP INTEGER.+");
+
+      interpreter.PrintStacks();
+    }
+
+    static async Task Stepwise() {
+      var interpreter = new PushInterpreter();
+
+      interpreter.RunAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
+
+      while (!interpreter.IsCompleted) {
+        Console.Clear();
+        interpreter.PrintStacks();
+        interpreter.Step();
+
+        var input = Console.ReadKey();
+        if (input.Key == ConsoleKey.Escape) {
+          break;
+        } else if (input.Key == ConsoleKey.Spacebar) {
+          await interpreter.ResumeAsync();
+        }
+      }
+
+      Console.Clear();
+      interpreter.PrintStacks();
+    }
+
+    static void PerformanceTestInterpreter() {
+      var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
+
+      var interpreter = new PushInterpreter();
+      var sw = new Stopwatch();
+
+      sw.Start();
+      for (var i = 0; i < 60000000; i++) {
+        interpreter.Run(program);
+        interpreter.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void PerformanceParallelTestInterpreter() {
+      var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
+
+      var sw = new Stopwatch();
+      var iterations = 100;
+      var amount = 600000;
+      var pool = new PushInterpreterPool(iterations, 1024);
+
+      sw.Start();
+      Parallel.For(0, iterations, i => {
+        using (var interpreter = pool.Create()) {
+          for (var j = 0; j < amount; j++) {
+            interpreter.Run(program);
+            interpreter.Clear();
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void PerformanceTestRecursiveCodeGenerator() {
+      var sw = new Stopwatch();
+      var random = new FastRandom(1337);
+
+      sw.Start();
+      var expressions = RecursiveCodeGenerator.RandomCode(60000000, random).ToList();
+      sw.Stop();
+
+      Console.WriteLine("Generated {0} in {1}", expressions.Count, sw.Elapsed);
+    }
+
+    static void PerformanceTestLinearCodeGenerator() {
+      var sw = new Stopwatch();
+      var random = new FastRandom(1337);
+      var poolProvider = new ManagedPoolProvider<PooledList<Expression>>(65636, () => new PooledList<Expression>());
+
+      sw.Start();
+      var expressions = LinearCodeGenerator.RandomCode(60000000, null, random).ToList();
+      sw.Stop();
+
+      Console.WriteLine("Generated {0} in {1}", expressions.Count, sw.Elapsed);
+    }
+
+    static void TestRobustness() {
+      var sw = new Stopwatch();
+      var parallelism = Environment.ProcessorCount;
+      var maxProgramSizeLimit = 1024;
+      var partitionSize = 100000;
+      var execCounters = new int[parallelism];
+
+      var config = new PushConfiguration {
+        EvalPushLimit = 1024,
+        MaxPointsInProgram = 1024,
+        IsCodeStackEnabled = false,
+        IsExecStackEnabled = false,
+        IsBooleanStackEnabled = false,
+        IsFloatStackEnabled = false,
+        IsIntegerStackEnabled = false,
+        IsNameStackEnabled = false,
+      };
+
+      config.DisableExpression<ExecYExpression>();
+
+      var pool = new PushInterpreterPool(config);
+
+      sw.Start();
+      Parallel.For(0, parallelism, i => {
+        var random = new FastRandom(1337);
+
+        using (var interpreter = pool.Create(random)) {
+          for (var j = 0; j < partitionSize; j++) {
+            var program = LinearCodeGenerator.RandomProgram(maxProgramSizeLimit, random, config);
+            interpreter.Run(program);
+
+            execCounters[i] += interpreter.ExecCounter;
+            interpreter.Clear();
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("ExecCount: {0}", execCounters.Sum());
+      Console.WriteLine("Duration: {0}", sw.Elapsed);
+    }
+
+    static void TestPool() {
+      var pool = new PushInterpreterPool();
+      var normal = new PushInterpreter();
+      int id;
+
+      using (var interpreter = pool.Create()) {
+        interpreter.Run("( 1 2 INTEGER.+ )");
+
+        id = interpreter.GetHashCode();
+        if (id == normal.GetHashCode()) Console.WriteLine("equal 1");
+      }
+
+      using (var interpreter = pool.Create())
+      using (var interpreter2 = pool.Create()) {
+        interpreter.Run("( 1 2 INTEGER.+ )");
+        if (id == interpreter.GetHashCode()) Console.WriteLine("equal 2");
+        if (id == interpreter2.GetHashCode()) Console.WriteLine("equal 3");
+      }
+    }
+
+    static void TestPoolPerformance() {
+      var sw = new Stopwatch();
+      var iterations = 100000000;
+
+      sw.Start();
+      for (var i = 0; i < iterations; i++) {
+        var interpreter = new PushInterpreter();
+        interpreter.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+
+      var pool = new PushInterpreterPool();
+      sw.Restart();
+      for (var i = 0; i < iterations; i++) {
+        using (var interpreter = pool.Create()) {
+          interpreter.Clear();
+        }
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void TestSimplifier() {
+      var program = PushParser.ParseProgram("( 5 ( INTEGER.DUP FLOAT.+ FLOAT.- ) ( EXEC.DO ( EXEC.IF ) EXEC.Y ) INTEGER.+ )");
+      var pool = new PushInterpreterPool();
+      var random = new FastRandom(1337);
+
+      var randomProg = LinearCodeGenerator.RandomProgram(4096 * 4, random);    // 53
+
+      Func<PushProgram, double> evaluator = prog => {
+        using (var interpreter = pool.Create(random)) {
+          interpreter.Run(prog);
+          return interpreter.IntegerStack.IsEmpty
+            ? double.MaxValue
+            : Math.Abs(interpreter.IntegerStack.Top - 10);
+        }
+      };
+
+      var simplerProgram = Simplifier.Simplify(program, evaluator);
+
+      Console.WriteLine(simplerProgram);
+    }
+  }
+
+  [Serializable]
+  class Person : IPooledObject {
+    public string Name { get; set; }
+    public int Age { get; set; }
+
+    public void Reset() {
+      Age = default(int);
+      Name = null;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Properties/AssemblyInfo.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Properties/AssemblyInfo.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Properties/AssemblyInfo.cs	(revision 14777)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("TestPooling")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("TestPooling")]
+[assembly: AssemblyCopyright("Copyright ©  2017")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("b184a849-1403-4f5f-96f8-952c6599a7c0")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14777)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.BenchmarkSuite {
-  using System;
   using System.Collections.Generic;
   using System.IO;
@@ -8,28 +7,15 @@
   using System.Text.RegularExpressions;
 
+  using HeuristicLab.BenchmarkSuite.ERC;
   using HeuristicLab.BenchmarkSuite.Problems;
-  using HeuristicLab.Common;
-  using HeuristicLab.Core;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
   using Microsoft.VisualBasic.FileIO;
 
 
-  [StorableClass]
-  public abstract class BenchmarkSuiteDataDescriptor : NamedItem, IBenchmarkSuiteDataDescriptor {
+  public abstract class BenchmarkSuiteDataDescriptor : IBenchmarkSuiteDataDescriptor {
     private const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
     private const string ResourcePath = @".*\.Data\.";
     private const string ExampleSeparator = ",";
 
-    private const char ArrayValueSeparator = ' ';
-    private static readonly char[] ArraySymbolTrim = { '[', ']' };
-
-    protected BenchmarkSuiteDataDescriptor() { }
-
-    [StorableConstructor]
-    protected BenchmarkSuiteDataDescriptor(bool deserializing) : base(deserializing) { }
-
-
-    [Storable]
     private Example[] examples;
     public Example[] Examples
@@ -41,14 +27,39 @@
     }
 
-    public new abstract string Name { get; }
+    public Data CreateProblemData() {
+      return new Data {
+        Name = Name,
+        Description = Description,
+        Examples = Examples.ToArray(),
+        BestResult = BestResult,
+        WorstResult = WorstResult,
+        InputArgumentTypes = InputArgumentTypes,
+        OutputArgumentTypes = OutputArgumentTypes,
+        OriginalTestCount = OriginalTestCount,
+        OriginalTrainingCount = OriginalTrainingCount,
+        EnabledDataTypes = EnabledDataTypes,
+        EvalLimit = EvalLimit,
+        MaxGenerations = MaxGenerations,
+        MaxSize = MaxSize,
+        ProgEvalBudget = ProgEvalBudget,
+        ProblemErcOptions = ProblemErcOptions,
+      };
+    }
+
+    public abstract string Name { get; }
+    public abstract string Description { get; }
     protected abstract string FileName { get; }
-    public new abstract string Description { get; }
     public abstract int OriginalTrainingCount { get; }
     public abstract int OriginalTestCount { get; }
     public abstract int BestResult { get; }
     public abstract int WorstResult { get; }
-    public abstract int InputArgumentCount { get; }
-    public abstract int OutputArgumentCount { get; }
-    public int TotalArgumentCount { get { return InputArgumentCount + OutputArgumentCount; } }
+    public abstract ExampleArgumentType[] InputArgumentTypes { get; }
+    public abstract ExampleArgumentType[] OutputArgumentTypes { get; }
+    public abstract ProblemErcOptions ProblemErcOptions { get; }
+    public abstract DataTypes EnabledDataTypes { get; }
+    public abstract int MaxSize { get; }
+    public abstract int EvalLimit { get; }
+    public abstract int MaxGenerations { get; }
+    public abstract int ProgEvalBudget { get; }
 
     public abstract Example ParseExample(string[] input, string[] output);
@@ -68,9 +79,9 @@
             var fields = parser.ReadFields();
 
-            if (fields.Length != TotalArgumentCount)
+            if (fields.Length != InputArgumentTypes.Length + OutputArgumentTypes.Length)
               throw new InvalidDataException("Number of values do not fit");
 
-            var input = fields.Take(InputArgumentCount).ToArray();
-            var output = fields.Skip(InputArgumentCount).ToArray();
+            var input = fields.Take(InputArgumentTypes.Length).ToArray();
+            var output = fields.Skip(OutputArgumentTypes.Length).ToArray();
 
             yield return ParseExample(input, output);
@@ -86,49 +97,4 @@
           .SingleOrDefault(x => Regex.Match(x, ResourcePath + fileName).Success);
     }
-
-    protected static double[] ConvertDoubles(string input) {
-      return ConvertMultiple(input, double.Parse);
-    }
-
-    protected static double ConvertDouble(string input) {
-      return double.Parse(input);
-    }
-
-    protected static long[] ConvertIntegers(string input) {
-      return ConvertMultiple(input, long.Parse);
-    }
-
-    protected static long ConvertInteger(string input) {
-
-      return string.IsNullOrEmpty(input) ? default(long) : long.Parse(input);
-    }
-
-    protected static T[] ConvertMultiple<T>(string input, Func<string, T> converter) {
-      return input
-       .Trim(ArraySymbolTrim)
-       .Split(ArrayValueSeparator)
-       .Where(s => !string.IsNullOrWhiteSpace(s))
-       .Select(converter)
-       .ToArray();
-    }
-
-    protected static IEnumerable<string> SplitByNewLine(string input) {
-      return input.Split(new[] { Environment.NewLine, "\n", "\r\n" }, StringSplitOptions.None);
-    }
-
-    private static string[] trueFormats = new[] { "true", "t", "1" };
-    private static string[] falseFormats = new[] { "false", "f", "0" };
-
-    protected static bool ConvertBool(string input) {
-      var str = input.ToLower();
-
-      if (trueFormats.Contains(str)) return true;
-      if (falseFormats.Contains(str)) return false;
-      throw new InvalidDataException(string.Format("Unable to parse {0} as boolean", str));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return this;
-    }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14777)
@@ -7,5 +7,5 @@
   using HeuristicLab.Problems.Instances;
 
-  public class BenchmarkSuiteInstanceProvider : ProblemInstanceProvider<IBenchmarkSuiteDataDescriptor> {
+  public class BenchmarkSuiteInstanceProvider : ProblemInstanceProvider<Data> {
     private const string name = "General Program Synthesis Benchmark Suite";
     private const string referencePublication =
@@ -36,5 +36,5 @@
       yield return new CountOdds();
       //yield return new CollatzNumbers();
-      yield return new Checksum();
+      //yield return new Checksum();
       //yield return new CompareStringLengths();
       //yield return new Digits();
@@ -52,6 +52,8 @@
     }
 
-    public override IBenchmarkSuiteDataDescriptor LoadData(IDataDescriptor descriptor) {
-      return (IBenchmarkSuiteDataDescriptor)descriptor;
+    public override Data LoadData(IDataDescriptor descriptor) {
+      var benchmarkSuiteDataDescriptor = (IBenchmarkSuiteDataDescriptor)descriptor;
+
+      return benchmarkSuiteDataDescriptor.CreateProblemData();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs	(revision 14777)
@@ -0,0 +1,21 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using System;
+
+  [Flags]
+  public enum DataTypes : ushort {
+    None = 0x00, // Required to specify expression dependencies
+    Integer = 0x02,
+    Float = 0x04,
+    Char = 0x08,
+    String = 0x10,
+    Boolean = 0x20,
+    Name = 0x40,
+    Code = 0x80,
+    Exec = 0x100,
+    IntegerVector = 0x200,
+    FloatVector = 0x400,
+    StringVector = 0x800,
+    Print = 0x1000,
+    FileInput = 0x2000,
+  }
+}
